package moe.oko.Kiafumi.command;

import moe.oko.Kiafumi.Kiafumi;
import moe.oko.Kiafumi.util.CommandInfo;
import net.dv8tion.jda.api.events.interaction.command.SlashCommandInteractionEvent;
import net.dv8tion.jda.api.events.message.MessageReceivedEvent;
import net.dv8tion.jda.api.hooks.ListenerAdapter;

import java.util.List;

public abstract class CommandClass extends ListenerAdapter {

    //Is the command enabled?
    public abstract boolean isEnabled();

    //Whats the name of the Command Package (Specify if multiple, like "Utility" or "Moderation")
    public abstract String getName();

    /**
     * Your execution function. What the CommandPlugin will include.
     * Use a CASE statement to help it out. (Soon to be deprecated in favour of slash cmds)
     * @param args - basic arguments send with the command for QOL.
     * @param e - MessageRecievedEvent for the sake of getting author or whatever.
     */
    @Deprecated
    public abstract void legacyCommand(String[] args, MessageReceivedEvent e, boolean prefix);

    /**
     * For new slash commands
     * @param name - name of the command executed
     * @param e - SlashCommandInteractionEvent, used for all references.
     */
    public abstract void newCommand(String name, SlashCommandInteractionEvent e);

    /**
     * Overriding our GuildMessageReceivedEvent that way we can execute a cmd...
     * @param event - Message received event
     */
    @Override
    public void onMessageReceived(MessageReceivedEvent event) {
        if(event.getAuthor().isBot() || event.getAuthor().isSystem()) return;
        if(event.getAuthor().getId().equals(Kiafumi.JDA.getSelfUser().getId())) return;
        if(!event.getChannel().canTalk()) return;

        String[] args = event.getMessage().getContentDisplay().replace(Kiafumi.PREFIX, "").split(" ");
        //Removes prefix from args and also splits the arguments into proper args.

        boolean prefixed = event.getMessage().getContentDisplay().startsWith(Kiafumi.PREFIX);
        legacyCommand(args, event, prefixed);
    }

    /**
     * Overriding our SlashCommandInteractionEvent that way it can execute a cmd.
     * @param event
     */
    @Override
    public void onSlashCommandInteraction(SlashCommandInteractionEvent event) {
        newCommand(event.getName(), event);
    }

    /**
     * @deprecated - soon to be removed in favour of getSlashCommandInfo()
     * For the sake of organization. Format the strings like so:
     * command - description.
     * @return
     */
    @Deprecated
    public abstract List<String> getCommandsAsList();

    /**
     * Also for the sake of organization. To upsert slash commands.
     * Follow as name, description. (for upsertCommand(name, description);
     * @return - The name and description for the commands contained within the class.
     */
    public abstract List<CommandInfo> getSlashCommandInfo();
}
